/**
 * Copyright (c) 2010 - 2012, Jason Mulligan <jason.mulligan@avoidwork.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of abaaso nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL JASON MULLIGAN BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * abaaso
 *
 * Events: init           Fires when abaaso is ready; register modules on this event
 *         ready          Fires when the DOM is available
 *         render         Fires when the window resources have loaded
 *         resize         Fires when the window resizes; parameter for listeners is abaaso.client.size
 *         afterCreate    Fires after an Element is created; parameter for listeners is the (new) Element
 *         afterDestroy   Fires after an Element is destroyed; parameter for listeners is the (removed) Element.id value
 *         beforeCreate   Fires when an Element is about to be created; parameter for listeners is the (new) Element.id value
 *         beforeDestroy  Fires when an Element is about to be destroyed; parameter for listeners is the (to be removed) Element
 *         error          Fires when an Error is caught; parameter for listeners is the logged Object (abaaso.error.log[n])
 *         beforeHash     Fires before the hash event
 *         hash           Fires when window.location.hash changes; parameter for listeners is the hash value
 *         afterHash      Fires after the hash event; parameter for listeners is the hash value
 *
 * @author Jason Mulligan <jason.mulligan@avoidwork.com>
 * @link http://abaaso.com/
 * @module abaaso
 * @version 2.8.0
 */
(function(e){"use strict";var t=e.document,n=e.location,r=e.navigator,i=typeof r=="undefined",s,o,u;o=e.abaaso||function(){var a,f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T,N,C;return f={add:function(e,t){return f.contains(e,t)||e.push(t),e},cast:function(e,t){t=t===!0;var n=[],r,i;switch(!0){case!isNaN(e.length):!c.ie||c.version>8?n=Array.prototype.slice.call(e):x.iterate(e,function(e,t){t!=="length"&&n.push(e)});break;default:t?n=f.keys(e):x.iterate(e,function(e){n.push(e)})}return n},clone:function(e){return x.clone(e)},contains:function(e,t){return f.index(e,t)>-1},diff:function(e,t){var n=e.length>t.length?e:t,r=n===e?t:e;return n.filter(function(e){return!f.contains(r,e)})},each:function(e,t){var n=e.length,r,i;for(r=0;r<n;r++){i=t.call(e,e[r],r);if(i===!1)break}return e},first:function(e){return e[0]},index:function(e,t){return e.indexOf(t)},indexed:function(e){var t=[];return x.iterate(e,function(e,n){typeof e=="object"?t=t.concat(f.indexed(e)):t.push(e)}),t},intersect:function(e,t){var n=e.length>t.length?e:t,r=n===e?t:e;return n.filter(function(e){return f.contains(r,e)})},keys:function(e){var t=[];return typeof Object.keys=="function"?t=Object.keys(e):x.iterate(e,function(e,n){t.push(n)}),t},last:function(e){return e[e.length-1]},range:function(e,t,n){var r=[],i;for(i=t;i<=n;i++)typeof e[i]!="undefined"&&r.push(e[i]);return r},remove:function(e,t,n){if(typeof t=="string"){t=e.index(t);if(t===-1)return e}else t=t||0;var r=e.length,i=e.slice((n||t)+1||r);return e.length=t<0?r+t:t,e.push.apply(e,i),e},sort:function(e,t){var n=!1,r;!isNaN(e)&&!isNaN(t)&&(n=!0),e=n?b.parse(e):String(e),t=n?b.parse(t):String(t);switch(!0){case e<t:r=-1;break;case e>t:r=1;break;default:r=0}return r},total:function(e){return f.indexed(e).length},toObject:function(e){var t={},n=e.length;while(n--)t[n.toString()]=e[n];return t}},l={items:{},clean:function(){return x.iterate(l.items,function(e,t){l.expired(t)&&l.expire(t)})},expire:function(e,t){return t=t===!0,typeof l.items[e]!="undefined"?(delete l.items[e],t||e.fire("beforeExpire, expire, afterExpire"),!0):!1},expired:function(e){var t=l.items[e];return typeof t!="undefined"&&typeof t.expires!="undefined"&&t.expires<new Date},get:function(e,t){return t=t!==!1,typeof l.items[e]=="undefined"?!1:t&&l.expired(e)?(l.expire(e),!1):x.clone(l.items[e])},set:function(e,t,n){return typeof l.items[e]=="undefined"&&(l.items[e]={},l.items[e].permission=0),t==="permission"?l.items[e].permission|=n:t==="!permission"?l.items[e].permission&=~n:l.items[e][t]=n,l.items[e]}},c={android:function(){return!i&&/android/i.test(r.userAgent)}(),blackberry:function(){return!i&&/blackberry/i.test(r.userAgent)}(),chrome:function(){return!i&&/chrome/i.test(r.userAgent)}(),firefox:function(){return!i&&/firefox/i.test(r.userAgent)}(),ie:function(){return!i&&/msie/i.test(r.userAgent)}(),ios:function(){return!i&&/ipad|iphone/i.test(r.userAgent)}(),linux:function(){return!i&&/linux|bsd|unix/i.test(r.userAgent)}(),mobile:function(){o.client.mobile=this.mobile=!i&&(/blackberry|iphone|webos/i.test(r.userAgent)||/android/i.test(r.userAgent)&&(o.client.size.height<720||o.client.size.width<720))},playbook:function(){return!i&&/playbook/i.test(r.userAgent)}(),opera:function(){return!i&&/opera/i.test(r.userAgent)}(),osx:function(){return!i&&/macintosh/i.test(r.userAgent)}(),safari:function(){return!i&&/safari/i.test(r.userAgent.replace(/chrome.*/i,""))}(),tablet:function(){o.client.tablet=this.tablet=!i&&(/ipad|playbook|webos/i.test(r.userAgent)||/android/i.test(r.userAgent)&&(o.client.size.width>=720||o.client.size.width>=720))},webos:function(){return!i&&/webos/i.test(r.userAgent)}(),windows:function(){return!i&&/windows/i.test(r.userAgent)}(),version:function(){var e=0;switch(!0){case this.chrome:e=r.userAgent.replace(/(.*chrome\/|safari.*)/gi,"");break;case this.firefox:e=r.userAgent.replace(/(.*firefox\/)/gi,"");break;case this.ie:e=parseInt(r.userAgent.replace(/(.*msie|;.*)/gi,"")),t.documentMode<e&&(e=t.documentMode);break;case this.opera:e=r.userAgent.replace(/(.*opera\/|\(.*)/gi,"");break;case this.safari:e=r.userAgent.replace(/(.*version\/|safari.*)/gi,"");break;default:e=typeof r!="undefined"?r.appVersion:0}return e=isNaN(parseInt(e))?0:parseInt(e),o.client.version=this.version=e,e},allows:function(e,t){if(e.isEmpty()||t.isEmpty())throw Error(m.error.invalidArguments);if(!l.get(e,!1))return undefined;t=t.toLowerCase();var n;switch(!0){case t==="delete":n=(c.permissions(e,t).bit&1)!==0;break;case t==="get":n=(c.permissions(e,t).bit&4)!==0;break;case/post|put/.test(t):n=(c.permissions(e,t).bit&2)!==0;break;default:n=!1}return n},bit:function(e){var t=0;return e.each(function(e){switch(e.toLowerCase()){case"get":t|=4;break;case"post":case"put":t|=2;break;case"delete":t|=1}}),t},cors:function(e){return!i&&e.indexOf("//")>-1&&e.indexOf("//"+n.host)===-1},headers:function(e,t,n){var r=String(e.getAllResponseHeaders()).split("\n"),i={},o={},u=null,a=new Date,f,h;r.each(function(e){e.isEmpty()||(f=e.toString(),h=f.substr(f.indexOf(":")+1,f.length).replace(/\s/,""),f=f.substr(0,f.indexOf(":")).replace(/\s/,""),f=function(){var e=[];return f.explode("-").each(function(t){e.push(t.capitalize())}),e.join("-")}(),i[f]=h,/allow|access-control-allow-methods/i.test(f)&&(u=h))});switch(!0){case typeof i["Cache-Control"]!="undefined"&&/no/.test(i["Cache-Control"]):case typeof i.Pragma!="undefined"&&/no/.test(i.Pragma):break;case typeof i["Cache-Control"]!="undefined"&&/\d/.test(i["Cache-Control"]):a=a.setSeconds(a.getSeconds()+parseInt(/\d{1,}/.exec(i["Cache-Control"])[0]));break;case typeof i.Expires!="undefined":a=new Date(i.Expires);break;default:a=a.setSeconds(a.getSeconds()+s.expires)}return o.expires=a,o.headers=i,o.permission=c.bit(u!==null?u.explode():[n]),n!=="head"&&(l.set(t,"expires",o.expires),l.set(t,"headers",o.headers),l.set(t,"permission",o.permission)),o},parse:function(e,t){t=t||"";var n,r;switch(!0){case(/json|plain|javascript/.test(t)||t.isEmpty())&&Boolean(r=v.decode(/[\{\[].*[\}\]]/.exec(e.responseText),!0)):n=r;break;case/xml/.test(t)&&String(e.responseText).isEmpty()&&e.responseXML!==null:n=N.decode(typeof e.responseXML.xml!="undefined"?e.responseXML.xml:e.responseXML);break;case/<[^>]+>[^<]*]+>/.test(e.responseText):n=N.decode(e.responseText);break;default:n=e.responseText}return n},permissions:function(e){var t=l.get(e,!1),n=t?t.permission:0,r={allows:[],bit:n,map:{read:4,write:2,"delete":1}};return n&1&&r.allows.push("DELETE"),n&2&&function(){r.allows.push("POST"),r.allows.push("PUT")}(),n&4&&r.allows.push("GET"),r},jsonp:function(t,n,r,i){var o=t,a=x.guid(!0),f,l,c;typeof u=="undefined"&&(typeof e.abaaso=="undefined"&&(e.abaaso={},e.abaaso.callback={}),u="abaaso");switch(!0){case typeof i=="undefined":case i===null:case i instanceof Object&&(i.callback===null||typeof i.callback=="undefined"):case typeof i=="string"&&i.isEmpty():f="callback";break;case i instanceof Object&&typeof i.callback!="undefined":f=i.callback;break;default:f="callback"}o=o.replace(f+"=?",""),o.once("afterJSONP",function(e){this.un("failedJSONP",a),typeof n=="function"&&n(e)},a).once("failedJSONP",function(){this.un("failedJSONP",a),typeof r=="function"&&r()},a);do l=x.genId().slice(0,10);while(typeof e.abaaso.callback[l]!="undefined");return t=t.replace(f+"=?",f+"="+u+".callback."+l),e.abaaso.callback[l]=function(t){c.destroy(),clearTimeout(x.timer[l]),delete x.timer[l],delete e.abaaso.callback[l],o.fire("afterJSONP",t)},c=s("head")[0].create("script",{src:t,type:"text/javascript"}),x.defer(function(){o.fire("failedJSONP")},3e4,l),t},request:function(e,t,n,r,i,s){var o,u,a,f,h,p,d,g,y,b;if(/post|put/i.test(t)&&typeof i=="undefined")throw Error(m.error.invalidArguments);t=t.toLowerCase(),s=s instanceof Object?s:null;try{o=c.cors(e),u=c.ie&&c.version<10&&o?new XDomainRequest:new XMLHttpRequest,a=/post|put/i.test(t)&&typeof i!="undefined"?i:null,f=t==="get"?l.get(e):!1,h=t.capitalize(),p=x.guid(!0),d=null,g=typeof Document!="undefined",y=typeof ArrayBuffer!="undefined",b=typeof Blob!="undefined"}catch(w){return C(w,arguments,this,!0),typeof r=="function"&&r(w),e}t==="delete"&&e.once("afterDelete",function(){l.expire(this)}),e.once("after"+h,function(t){e.un("failed"+h,p),typeof n=="function"&&n(t)},p).once("failed"+h,function(t){e.un("after"+h,p),typeof r=="function"&&r(t)},p).fire("before"+h);if(t!=="head"&&e.allows(t)===!1)return e.fire("failed"+h);if(t==="get"&&Boolean(f))e.fire("afterGet",f.response);else{u[u instanceof XMLHttpRequest?"onreadystatechange":"onload"]=function(){c.response(u,e,t)},typeof u.ontimeout!="undefined"&&(u.ontimeout=function(t){e.fire("timeout"+h,t)}),typeof u.onprogress!="undefined"&&(u.onprogress=function(t){e.fire("progress"+h,t)}),typeof u.upload!="undefined"&&typeof u.upload.onprogress!="undefined"&&(u.upload.onprogress=function(t){e.fire("progressUpload"+h,t)});try{u.open(t.toUpperCase(),e,!0),s!==null&&s.hasOwnProperty("Content-Type")&&(d=s["Content-Type"]),o&&d===null&&(d="text/plain"),a!==null&&(a.hasOwnProperty("xml")&&(a=a.xml),g&&a instanceof Document&&(a=N.decode(a)),typeof a=="string"&&/<[^>]+>[^<]*]+>/.test(a)&&(d="application/xml"),!(y&&a instanceof ArrayBuffer)&&!(b&&a instanceof Blob)&&a instanceof Object&&(d="application/json",a=v.encode(a)),d===null&&(y&&a instanceof ArrayBuffer||b&&a instanceof Blob)&&(d="application/octet-stream"),d===null&&(d="application/x-www-form-urlencoded; charset=UTF-8")),typeof u.setRequestHeader!="undefined"&&(typeof f=="object"&&f.headers.hasOwnProperty("ETag")&&u.setRequestHeader("ETag",f.headers.ETag),s===null&&(s={}),d!==null&&(s["Content-Type"]=d),s.hasOwnProperty("callback")&&delete s.callback,x.iterate(s,function(e,t){e!==null&&t!=="withCredentials"&&u.setRequestHeader(t,e)})),typeof u.withCredentials=="boolean"&&s!==null&&typeof s.withCredentials=="boolean"&&(u.withCredentials=s.withCredentials),e.fire("beforeXHR",{xhr:u,uri:e}),a!==null?u.send(a):u.send()}catch(w){C(w,arguments,this,!0),e.fire("failed"+h,{response:c.parse(u),xhr:u})}}return e},response:function(e,t,r){var i=r.toLowerCase().capitalize(),s=n,u=null,a,f,h,p,d;switch(!0){case e.readyState===2:t.fire("received"+i);break;case e.readyState===4:t.fire("afterXHR",{xhr:e,uri:t});try{switch(e.status){case 200:case 201:case 202:case 203:case 204:case 205:case 206:case 301:a=o.state,f=c.headers(e,t,r),h=c.cors(t);switch(!0){case r==="head":return t.fire("afterHead",f.headers);case r!=="delete"&&/200|201/.test(e.status):d=typeof f.headers["Content-Type"]!="undefined"?f.headers["Content-Type"]:"",p=c.parse(e,d);if(typeof p=="undefined")throw Error(m.error.serverError);l.set(t,"response",f.response=x.clone(p))}a.header!==null&&Boolean(u=f.headers[a.header])&&a.current!==u&&(typeof a.change=="function"?a.change(u):a.current=u);switch(e.status){case 200:case 201:t.fire("after"+i,p);break;case 202:case 203:case 204:case 206:t.fire("after"+i);break;case 205:t.fire("reset");break;case 301:t.fire("moved",p)}break;case 401:throw Error(m.error.serverUnauthorized);case 403:throw l.set(t,"!permission",c.bit([r])),Error(m.error.serverForbidden);case 405:throw l.set(t,"!permission",c.bit([r])),Error(m.error.serverInvalidMethod);case 0:default:throw Error(m.error.serverError)}}catch(g){C(g,arguments,this,!0),t.fire("failed"+i,{response:c.parse(e),xhr:e})}break;case c.ie&&c.cors(t):var p,y;switch(!0){case Boolean(y=v.decode(/[\{\[].*[\}\]]/.exec(e.responseText))):p=y;break;case/<[^>]+>[^<]*]+>/.test(e.responseText):p=N.decode(e.responseText);break;default:p=e.responseText}l.set(t,"permission",c.bit(["get"])),l.set(t,"response",p),t.fire("afterGet",p)}return t},size:function(){var e=i?{clientHeight:0,clientWidth:0}:typeof t.documentElement!="undefined"?t.documentElement:t.body;return{height:e.clientHeight,width:e.clientWidth}}},h={expire:function(e,t,n){return typeof h.get(e)!="undefined"&&h.set(e,"","-1s",t,n),e},get:function(e){return h.list()[e]},list:function(){var e={},n,r;return typeof t.cookie!="undefined"&&!t.cookie.isEmpty()&&(r=t.cookie.explode(";"),r.each(function(t){n=t.explode("="),e[decodeURIComponent(n[0].toString().trim())]=decodeURIComponent(n[1].toString().trim())})),e},set:function(e,n,r,i,s){typeof n=="undefined"&&(n=""),n+=";",typeof r=="undefined"&&(r=""),i=typeof i=="string"?" domain="+i+";":"",s=s===!0?"; secure":"";var o="",u=null,a=null,f=["d","h","m","s"],l=new RegExp,c=f.length;if(!r.isEmpty()){while(c--){x.compile(l,f[c]);if(l.test(r)){a=f[c],u=parseInt(r);break}}if(isNaN(u))throw Error(m.error.invalidArguments);o=new Date;switch(a){case"d":o.setDate(o.getDate()+u);break;case"h":o.setHours(o.getHours()+u);break;case"m":o.setMinutes(o.getMinutes()+u);break;case"s":o.setSeconds(o.getSeconds()+u)}}return o instanceof Date&&(o=" expires="+o.toUTCString()+";"),t.cookie=e.toString().trim()+"="+n+o+i+" path=/"+s,h.get(e)}},p={methods:{batch:function(e,t,n){e=e.toString().toLowerCase(),n=n===!0;if(!/^(set|del)$/.test(e)||typeof t!="object")throw Error(m.error.invalidArguments);var r=this.parentNode,i=this,o=0,u=0,a=!1,l=x.genId(!0),c,h,p,d,v;c=function(){e==="del"&&this.reindex(),i.loaded=!0,r.fire("afterDataBatch")},h=function(e){r.fire("failedDataSet, failedDataBatch",e)},d=function(e,t){var f=x.genId(),l={};typeof l.batch!="function"?l=x.clone(e):s.iterate(e,function(e,t){i.collections.contains(t)||(l[t]=x.clone(e))}),i.key!==null&&typeof l[i.key]!="undefined"&&(t=l[i.key],delete l[i.key]),r.once("afterDataSet",function(){this.un("failedDataSet",f),++o&&o===u&&c()},f).once("failedDataSet",function(){this.un("afterDataSet",f),a||(a=!0,this.fire("failedDataBatch"))},f),i.set(t,l,n)},r.fire("beforeDataBatch",t),e==="del"&&r.on("afterDataDelete",function(){o++&&o===u&&(r.un("afterDataDelete, failedDataDelete",l),c())},l).once("failedDataDelete",function(){r.un("afterDataDelete",l),a||(a=!0,r.fire("failedDataBatch"))},l);if(t instanceof Array){u=t.length;switch(u){case 0:c();break;default:t.each(function(t,r){r=r.toString();if(e==="set")switch(!0){case typeof t=="object":d(t,r);break;case t.indexOf("//")===-1:t=i.uri+t;default:t.get(function(e){d(i.source===null?e:x.walk(e,i.source),r)},h,x.merge({withCredentials:i.credentials},i.headers))}else i.del(t,!1,n)})}}else u=f.cast(t,!0).length,x.iterate(t,function(t,r){e==="set"?(i.key!==null&&typeof t[i.key]!="undefined"?(p=t[i.key],delete t[i.key]):p=r.toString(),i.set(p,t,n)):i.del(t,!1,n)});return this},clear:function(e){e=e===!0;var t=this.parentNode;return e?(this.collections=[],this.crawled=!1,this.keys={},this.loaded=!1,this.records=[],this.total=0,this.views={}):(t.fire("beforeDataClear"),this.callback=null,this.collections=[],this.crawled=!1,this.credentials=null,this.expires=null,this._expires=null,this.headers={Accept:"application/json"},this.ignore=[],this.key=null,this.keys={},this.loaded=!1,this.pointer=null,this.records=[],this.recursive=!1,this.retrieve=!1,this.source=null,this.total=0,this.views={},this.uri=null,this._uri=null,t.fire("afterDataClear")),this},crawl:function(e,t,n){var r=!1,i=this,s;if(typeof e!="number"&&typeof e!="string")throw Error(m.error.invalidArguments);return this.crawled=!0,this.loaded=!1,s=this.get(e),s=this.records[this.keys[s.key].index],n=n||this.key,typeof t=="string"&&(r=!0,t=t.explode()),x.iterate(s.data,function(e,o){if(typeof e!="string"||r&&t.contains(o))return;e.indexOf("//")>=0&&(i.collections.contains(o)||i.collections.push(o),s.data[o]=p.register({id:s.key+"-"+o}),s.data[o].once("afterDataSync",function(){this.fire("afterDataRetrieve")},"dataRetrieve"),s.data[o].data.headers=x.merge(s.data[o].data.headers,i.headers),t.each(function(e){s.data[o].data.ignore.add(e)}),s.data[o].data.key=n,s.data[o].data.pointer=i.pointer,s.data[o].data.source=i.source,i.recursive&&i.retrieve&&(s.data[o].data.recursive=!0,s.data[o].data.retrieve=!0),typeof s.data[o].data.setUri=="function"?s.data[o].data.setUri(e):s.data[o].data.uri=e)}),this.get(e)},del:function(e,t,n){if(typeof e=="undefined"||typeof e!="number"&&typeof e!="string")throw Error(m.error.invalidArguments);t=t!==!1,n=n===!0;var r=this.parentNode,i=/true|undefined/,s,o,u,a;switch(typeof e){case"string":s=e,e=this.keys[s];if(typeof s=="undefined")throw Error(m.error.invalidArguments);e=e.index;break;default:s=this.records[e];if(typeof s=="undefined")throw Error(m.error.invalidArguments);s=s.key}o={key:s,record:e,reindex:t},!n&&this.callback===null&&this.uri!==null&&(u=this.uri+"/"+s,a=u.allows("delete")),r.fire("beforeDataDelete",o);switch(!0){case n:case this.callback!==null:case this.uri===null:r.fire("syncDataDelete",o);break;case i.test(a):u.del(function(){r.fire("syncDataDelete",o)},function(){r.fire("failedDataDelete",o)},x.merge({withCredentials:this.credentials},this.headers));break;default:r.fire("failedDataDelete",o)}return this},find:function(e,t,n){if(typeof e=="undefined")throw Error(m.error.invalidArguments);e=typeof e=="string"?e.explode():[e],t=typeof t=="string"?t.explode():null;var r=[],i=this.parentNode,s=[],o=new RegExp;if(this.total===0)return r;switch(!0){case typeof n=="undefined":case String(n).isEmpty():n="gi";break;case n===null:n=""}return t===null?this.records.each(function(t){x.iterate(t.data,function(i,u){if(s.contains(t.key))return!1;if(typeof i.data=="object")return;e.each(function(e){x.compile(o,e,n);if(o.test(i))return s.push(t.key),r.add(t),!1})})}):this.records.each(function(i){t.each(function(t){if(s.contains(i.key))return!1;if(typeof i.data[t]=="undefined"||typeof i.data[t].data=="object")return;e.each(function(e){x.compile(o,e,n);if(o.test(i.data[t]))return s.push(i.key),r.add(i),!1})})}),r},form:function(e,t,n){n=n!==!1;var r=e===null,i=this,o,u,a,f,l,c;switch(!0){case r:e=this.get(0);break;case!(e instanceof Object):e=this.get(e)}switch(!0){case typeof e=="undefined":throw Error(m.error.invalidArguments);case this.uri!==null&&!this.uri.allows("post"):throw Error(m.error.serverInvalidMethod)}return l=e.key,c=e.data,typeof t!="undefined"&&(t=x.object(t)),this.uri!==null?(o=this.uri.replace(/.*\//,"").replace(/\?.*/,""),o.isDomain()&&(o=o.replace(/\..*/g,""))):o="record",a=function(e){var t=e.srcElement.parentNode,r=s("#"+t.id+" input"),o=r[0].name.match(/(.*)\[/)[1],u=!0,a={},f;i.parentNode.fire("beforeDataFormSubmit"),n&&(u=t.validate());switch(u){case!1:i.parentNode.fire("failedDataFormSubmit");break;case!0:r.each(function(e){if(typeof e.type!="undefined"&&/button|submit|reset/.test(e.type))return;x.define(e.name.replace("[",".").replace("]",""),e.value,a)}),f=x.genId(!0),i.parentNode.once("afterDataSet",function(){t.destroy()}),i.set(l,a[o])}i.parentNode.fire("afterDataFormSubmit",l)},f=function(e,t,n){var i,s;x.iterate(e,function(e,o){switch(!0){case e instanceof Array:i=0,e.each(function(e){f(e,t,n+"["+o+"]["+i++ +"]")});break;case e instanceof Object:f(e,t,n+"["+o+"]");break;default:s=(n+"["+o+"]").replace(/\[|\]/g,""),t.create("label",{"for":s}).html(o.capitalize()),t.create("input",{id:s,name:n+"["+o+"]",type:"text",value:r?"":e})}})},this.parentNode.fire("beforeDataForm"),u=d.create("form",{style:"display:none;"},t),f(c,u,o),u.create("input",{type:"button",value:m.common.submit}).on("click",function(e){a(e)}),u.create("input",{type:"reset",value:m.common.reset}),u.css("display","inherit"),this.parentNode.fire("afterDataForm",u),u},get:function(e,t){var n=this.records,r=this.parentNode,i;switch(!0){case typeof e=="undefined":case String(e).length===0:i=n;break;case typeof e=="string"&&typeof this.keys[e]!="undefined":i=n[this.keys[e].index];break;case typeof e=="number"&&typeof t=="undefined":i=n[parseInt(e)];break;case typeof e=="number"&&typeof t=="number":i=n.range(parseInt(e),parseInt(t));break;default:i=undefined}return i},reindex:function(){var e=this.total,t=this.parentNode,n=this.key!==null,r;this.views={};for(r=0;r<e;r++)!n&&this.records[r].key.isNumber()&&(delete this.keys[this.records[r].key],this.keys[r.toString()]={},this.records[r].key=r.toString()),this.keys[this.records[r].key].index=r;return this},set:function(e,t,n){e===null&&(e=undefined),n=n===!0;switch(!0){case(typeof e=="undefined"||String(e).isEmpty())&&this.uri===null:case typeof t=="undefined":case t instanceof Array:case t instanceof Number:case t instanceof String:case typeof t!="object":throw Error(m.error.invalidArguments)}var r=typeof e=="undefined"?undefined:this.get(e),i=this.parentNode,s=typeof e=="undefined"?"post":"put",o={data:typeof r!="undefined"?x.merge(r.data,t):t,key:e,record:undefined},u=this.uri,a=/true|undefined/,f;typeof r!="undefined"&&(o.record=this.records[this.keys[r.key].index]),this.collections.each(function(e){typeof o.data[e]=="object"&&delete o.data[e]}),!n&&this.callback===null&&u!==null&&(typeof r!="undefined"&&(u+="/"+r.key),f=u.allows(s)),i.fire("beforeDataSet",{key:e,data:t});switch(!0){case n:case this.callback!==null:case this.uri===null:i.fire("syncDataSet",o);break;case a.test(f):u[s](function(e){o.result=e,i.fire("syncDataSet",o)},function(e){i.fire("failedDataSet")},t,x.merge({withCredentials:this.credentials},this.headers));break;default:i.fire("failedDataSet",o)}return this},sort:function(e,t,n){if(typeof e=="undefined"||String(e).isEmpty())throw Error(m.error.invalidArguments);/ci|cs|ms/.test(n)||(n="ci"),t=t===!0;var r=e.replace(/\s*asc/g,"").replace(/,/g," ").toCamelCase()+n.toUpperCase(),i=e.explode(),s=/:::(.*)$/,o=/\s*asc$/i,u=/\s*desc$/i,a=/^null/,l=this.key,c=[],h,p,d;return i.each(function(e){if(String(e).isEmpty())throw Error(m.error.invalidArguments)}),!t&&this.views[r]instanceof Array?this.views[r]:this.total===0?[]:(d=function(e,t){var n=e.clone(),r=e.first(),i={},s=[];return n.remove(0),i=h(r,t,u.test(r)),i.order.each(function(e){if(i.registry[e].length<2)return;n.length>0&&(i.registry[e]=d(n,i.registry[e]))}),i.order.each(function(e){s=s.concat(i.registry[e])}),s},h=function(e,t,r){e=e.replace(o,"");var i=e.replace(u,""),s=l===i,a=[],c={};return t.each(function(e){var t=s?e.key:e.data[i],r=t===null?"null":String(t);switch(n){case"ci":r=r.toCamelCase();break;case"cs":r=r.trim();break;case"ms":r=r.trim().slice(0,1).toLowerCase()}c[r]instanceof Array||(c[r]=[],a.push(r)),c[r].push(e)}),a.sort(f.sort),r&&a.reverse(),a.each(function(t){if(c[t].length===1)return;c[t]=p(c[t],e,i,r,s)}),{order:a,registry:c}},p=function(e,t,n,r,i){var o=[],u=[];return e.each(function(e,t){var r=i?e.key:e.data[n];r=String(r).trim()+":::"+t,o.push(r.replace(a,'""'))}),o.length>1&&(o.sort(f.sort),r&&o.reverse()),o.each(function(t){u.push(e[s.exec(t)[1]])}),u},c=d(i,this.records),this.views[r]=c,c)},sync:function(e){if(this.uri===null||this.uri.isEmpty())throw Error(m.error.invalidArguments);e=e===!0;var t=this,n=t.parentNode,r=x.guid(!0),i,s;return i=function(r){try{if(typeof r!="object")throw Error(m.error.expectedObject);var i,s=!1,o=x.genId(!0);t.source!==null&&(r=x.walk(r,t.source)),r instanceof Array?i=r:x.iterate(r,function(e){!s&&e instanceof Array&&(s=!0,i=e)}),typeof i=="undefined"&&(i=[r]),n.once("afterDataBatch",function(n){e&&t.reindex(),this.un("failedDataBatch",o).fire("afterDataSync",t.get())},o),n.once("failedDataBatch",function(e){t.clear(!0),this.un("afterDataBatch",o).fire("failedDataSync")},o),t.batch("set",i,!0)}catch(u){C(u,arguments,this),n.fire("failedDataSync",r)}},s=function(e){n.fire("failedDataSync",e)},n.fire("beforeDataSync"),this.callback!==null?this.uri.jsonp(i,s,{callback:this.callback}):this.uri.get(i,s,x.merge({withCredentials:this.credentials},this.headers)),this},teardown:function(){var e=this.uri,t,n;return e!==null&&(l.expire(e,!0),w.remove(e),n=this.parentNode.id+"DataExpire",typeof s.repeating[n]!="undefined"&&(clearTimeout(s.repeating[n]),delete s.repeating[n]),t=this.get(),t.each(function(t){l.expire(e+"/"+t.key,!0),w.remove(e+"/"+t.key),x.iterate(t.data,function(e,t){if(e===null)return;e.hasOwnProperty("data")&&typeof e.data.teardown=="function"&&(w.remove(e.id),e.data.teardown())})})),this.clear(!0),this}},register:function(e,t){if(e instanceof Array)return e.each(function(e){t.register(e,t)});var n={expires:{getter:function(){return this._expires},setter:function(e){if(e!==null&&this.uri===null&&isNaN(e))throw Error(m.error.invalidArguments);if(this._expires===e)return;this._expires=e;var t=this.parentNode.id+"DataExpire",n=e,r=this;clearTimeout(s.repeating[t]),delete s.repeating[t];if(e===null)return;x.defer(function(){x.repeat(function(){if(r.uri===null)return typeof r.setExpires=="function"?r.setExpires(null):r.expires=null,!1;l.expire(r.uri)||r.uri.fire("beforeExpire, expire, afterExpire")},n,t)},n)}},uri:{getter:function(){return this._uri},setter:function(e){if(e!==null&&e.isEmpty())throw Error(m.error.invalidArguments);switch(!0){case this._uri===e:return;case this._uri!==null:this._uri.un("expire","dataSync"),this.teardown(!0);default:this._uri=e}e!==null&&(e.on("expire",function(){this.sync(!0)},"dataSync",this),l.expire(e,!0),this.sync())}}};e=x.object(e),x.genId(e),typeof e.fire=="undefined"&&(e.fire=function(e,t){return s.fire.call(this,e,t)}),typeof e.listeners=="undefined"&&(e.listeners=function(e){return s.listeners.call(this,e)}),typeof e.on=="undefined"&&(e.on=function(e,t,n,r,i){return s.on.call(this,e,t,n,r,i)}),typeof e.once=="undefined"&&(e.once=function(e,t,n,r,i){return s.once.call(this,e,t,n,r,i)}),typeof e.un=="undefined"&&(e.un=function(e,t){return s.un.call(this,e,t)}),e.fire("beforeDataStore"),e.data=x.extend(this.methods),e.data.parentNode=e,e.data.clear(),e.on("syncDataDelete",function(e){var t=this.get(e.record);return this.records.remove(e.record),delete this.keys[e.key],this.total--,this.views={},e.reindex&&this.reindex(),x.iterate(t.data,function(e,t){if(e===null)return;typeof e.data!="undefined"&&typeof e.data.teardown=="function"&&e.data.teardown()}),this.parentNode.fire("afterDataDelete",t),this.parentNode},"recordDelete",e.data),e.on("syncDataSet",function(e){var t=typeof e.record=="undefined"?x.clone(e):e,n=!0,r=this,i,s;switch(!0){case typeof t.record=="undefined":var o=this.total;this.total++;if(typeof t.key=="undefined"){if(typeof t.result=="undefined")throw this.fire("failedDataSet"),Error(m.error.expectedObject);this.source!==null&&(t.result=x.walk(t.result,this.source)),this.key===null?t.key=f.cast(t.result).first():(t.key=t.result[this.key],delete t.result[this.key]),typeof t.key!="string"&&(t.key=t.key.toString()),t.data=t.result}this.keys[t.key]={},this.keys[t.key].index=o,this.records[o]={},i=this.records[o],i.key=t.key;if(this.pointer===null||typeof t.data[this.pointer]=="undefined")i.data=t.data,this.key!==null&&this.records[o].data.hasOwnProperty(this.key)&&delete this.records[o].data[this.key];else{n=!1,s=t.data[this.pointer];if(typeof s=="undefined"||s===null)throw delete this.records[o],delete this.keys[t.key],this.fire("failedDataSet"),Error(m.error.expectedObject);i.data={},s.get(function(e){r.source!==null&&(e=x.walk(e,r.source)),typeof e[r.key]!="undefined"&&delete e[r.key],x.merge(i.data,e),r.retrieve&&(r.crawl(i.key,r.ignore.length>0?r.ignore.join(","):undefined,r.key),r.loaded=!0),r.parentNode.fire("afterDataSet",i)},function(){r.parentNode.fire("failedDataSet")},r.headers)}break;default:t.record.data=t.data,i=t.record}this.views={},this.retrieve&&this.crawl(i.key,this.ignore.length>0?this.ignore.join(","):undefined,this.key),n&&this.parentNode.fire("afterDataSet",i)},"recordSet",e.data);switch(!0){case!c.ie||c.version>8:x.property(e.data,"uri",{enumerable:!0,get:n.uri.getter,set:n.uri.setter}),x.property(e.data,"expires",{enumerable:!0,get:n.expires.getter,set:n.expires.setter});break;default:e.data.setExpires=function(t){e.data.expires=t,n.expires.setter.call(e.data,t)},e.data.setUri=function(t){e.data.uri=t,n.uri.setter.call(e.data,t)}}return typeof t=="object"&&e.data.batch("set",t),e.fire("afterDataStore"),e}},d={attr:function(e,t,n){typeof n=="string"&&(n=n.trim());var r=/checked|disabled/,i;e=x.object(e);if(e instanceof Array)return e.attr(t,n);if(!(e instanceof Element&&typeof t!="undefined"&&!String(t).isEmpty()))throw Error(m.error.invalidArguments);switch(!0){case r.test(t)&&typeof n=="undefined":return e[t];case r.test(t)&&typeof n!="undefined":return e[t]=n,e;case e.nodeName==="SELECT"&&t==="selected"&&typeof n=="undefined":return s("#"+e.id+' option[selected="selected"]').first()||s("#"+e.id+" option").first();case e.nodeName==="SELECT"&&t==="selected"&&typeof n!="undefined":return i=s("#"+e.id+' option[selected="selected"]').first(),typeof i!="undefined"&&(i.selected=!1,i.removeAttribute("selected")),i=s("#"+e.id+' option[value="'+n+'"]').first(),i.selected=!0,i.setAttribute("selected","selected"),e;case typeof n=="undefined":return e.getAttribute(t);case n===null:return e.removeAttribute(t),e;default:return e.setAttribute(t,n),e}},clear:function(e){e=x.object(e);if(e instanceof Array)return e.each(function(e){d.clear(e)});if(e instanceof Element){e.fire("beforeClear");switch(!0){case typeof e.reset=="function":e.reset();break;case typeof e.value!="undefined":e.update({innerHTML:"",value:""});break;default:e.update({innerHTML:""})}return e.fire("afterClear"),e}throw Error(m.error.invalidArguments)},create:function(e,n,r,i){if(typeof e=="undefined"||String(e).isEmpty())throw Error(m.error.invalidArguments);var o,u,a;switch(!0){case typeof r!="undefined":r=x.object(r);break;case typeof n!="undefined"&&(typeof n=="string"||typeof n.childNodes!="undefined"):r=x.object(n);break;default:r=t.body}if(typeof r=="undefined")throw Error(m.error.invalidArguments);a=!(r instanceof Element),u=typeof n!="undefined"&&typeof n!="string"&&typeof n.childNodes=="undefined"&&typeof n.id!="undefined"&&typeof s("#"+n.id)=="undefined"?n.id:x.genId(),typeof n!="undefined"&&typeof n.id!="undefined"&&delete n.id,s.fire("beforeCreate",u),a?a&&r.parentNode!==null&&r.parentNode.fire("beforeCreate",u):r.fire("beforeCreate",u),o=t.createElement(e),o.id=u,typeof n=="object"&&typeof n.childNodes=="undefined"&&o.update(n);switch(!0){case typeof i=="undefined":case i==="last":r.appendChild(o);break;case i==="first":r.prependChild(o);break;case i==="after":i={},i.after=r,r=r.parentNode;case typeof i.after!="undefined":r.insertBefore(o,i.after.nextSibling);break;case i==="before":i={},i.before=r,r=r.parentNode;case typeof i.before!="undefined":r.insertBefore(o,i.before);break;default:r.appendChild(o)}return a?a&&r.parentNode!==null&&r.parentNode.fire("afterCreate",o):r.fire("afterCreate",o),s.fire("afterCreate",o),o},css:function(e){var n,r;return n=s("head").first().create("style",{type:"text/css"}),n.styleSheet?n.styleSheet.cssText=e:(r=t.createTextNode(e),n.appendChild(r)),n},data:function(e,t,n){var r;return typeof n!="undefined"?(typeof e.dataset=="object"?e.dataset[t]=n:d.attr(e,"data-"+t,n),r=e):r=x.coerce(typeof e.dataset=="object"?e.dataset[t]:d.attr(e,"data-"+t)),r},destroy:function(e){e=x.object(e);if(e instanceof Array)return e.each(function(e){d.destroy(e)}),[];if(e instanceof Element)return s.fire("beforeDestroy",e),e.fire("beforeDestroy"),w.remove(e.id),e.parentNode!==null&&e.parentNode.removeChild(e),e.fire("afterDestroy"),s.fire("afterDestroy",e.id),undefined;throw Error(m.error.invalidArguments)},disable:function(e){e=x.object(e);if(e instanceof Array)return e.each(function(e){d.disable(e)});if(e instanceof Element)return typeof e.disabled=="boolean"&&!e.disabled&&(e.fire("beforeDisable"),e.disabled=!0,e.fire("afterDisable")),e;throw Error(m.error.invalidArguments)},enable:function(e){e=x.object(e);if(e instanceof Array)return e.each(function(e){d.enable(e)});if(e instanceof Element)return typeof e.disabled=="boolean"&&e.disabled&&(e.fire("beforeEnable"),e.disabled=!1,e.fire("afterEnable")),e;throw Error(m.error.invalidArguments)},find:function(e,t){var n=[];e=x.object(e);if(e instanceof Element&&typeof t=="string")return x.genId(e),t.explode().each(function(t){s("#"+e.id+" "+t).each(function(e){n.add(e)})}),n;throw Error(m.error.invalidArguments)},has:function(e,t){var n=d.find(e,t);return!isNaN(n.length)&&n.length>0},hasClass:function(e,t){e=x.object(e);if(e instanceof Array)return e.each(function(e){d.hide(e)});if(e instanceof Element)return e.className.explode(" ").contains(t);throw Error(m.error.invalidArguments)},hide:function(e){e=x.object(e);if(e instanceof Array)return e.each(function(e){d.hide(e)});if(e instanceof Element){e.fire("beforeHide");switch(!0){case typeof e.hidden=="boolean":e.hidden=!0;break;default:e["data-display"]=e.style.display,e.style.display="none"}return e.fire("afterHide"),e}throw Error(m.error.invalidArguments)},hidden:function(e){e=x.object(e);if(e instanceof Element)return e.style.display==="none"||typeof e.hidden=="boolean"&&e.hidden;throw Error(m.error.invalidArguments)},is:function(e,t){e=x.object(e);if(e instanceof Element&&typeof t=="string")return x.genId(e),/^:/.test(t)?d.find(e.parentNode,e.nodeName.toLowerCase()+t).contains(e):(new RegExp(t,"i")).test(e.nodeName);throw Error(m.error.invalidArguments)},klass:function(e,t,n){var r;e=x.object(e);if(e instanceof Array)return e.each(function(e){d.klass(e,t,n)});if(e instanceof Element&&!String(t).isEmpty())return e.fire("beforeClassChange"),n=n!==!1,t=t.explode(),r=e.className.explode(" "),t.each(function(e){n?r.add(e):t==="*"?r=[]:r.remove(e)}),r=r.join(" "),c.ie&&c.version<9?e.className=r:e.attr("class",r),e.fire("afterClassChange"),e;throw Error(m.error.invalidArguments)},position:function(n){n=x.object(n);if(n instanceof Array)return n.position();if(n instanceof Element){var r,i,s,o;r=i=0,o=n.offsetWidth,s=n.offsetHeight;if(n.offsetParent){i=n.offsetTop,r=n.offsetLeft;while(n=n.offsetParent)r+=n.offsetLeft,i+=n.offsetTop}return{top:i,right:t.documentElement.clientWidth-(r+o),bottom:t.documentElement.clientHeight+e.scrollY-(i+s),left:r}}throw Error(m.error.invalidArguments)},prependChild:function(e,t){e=x.object(e);if(e instanceof Element&&t instanceof Element)return e.childNodes.length===0?e.appendChild(t):e.insertBefore(t,e.childNodes[0]);throw Error(m.error.invalidArguments)},show:function(e){e=x.object(e);if(e instanceof Array)return e.each(function(e){d.show(e)});if(e instanceof Element){e.fire("beforeShow");switch(!0){case typeof e.hidden=="boolean":e.hidden=!1;break;default:e.style.display=e.getAttribute("data-display")!==null?e.getAttribute("data-display"):"inherit"}return e.fire("afterShow"),e}throw Error(m.error.invalidArguments)},size:function(e){var t,n,r;e=x.object(e);if(e instanceof Array){var i=[];return e.each(function(e){i.push(d.size(e))}),i}if(e instanceof Element)return t=function(e){return isNaN(parseInt(e))?0:parseInt(e)},n=e.offsetHeight+t(e.style.paddingTop)+t(e.style.paddingBottom)+t(e.style.borderTop)+t(e.style.borderBottom),r=e.offsetWidth+t(e.style.paddingLeft)+t(e.style.paddingRight)+t(e.style.borderLeft)+t(e.style.borderRight),{height:n,width:r};throw Error(m.error.invalidArguments)},text:function(e,t){var n=typeof e.textContent!="undefined"?"textContent":"innerText",r={},i=!1;return typeof t!="undefined"&&(i=!0,r[n]=t),i?d.update(e,r):e[n]},update:function(e,t){e=x.object(e),t=t||{};var n;if(e instanceof Array)return e.each(function(e){d.update(e,t)});if(e instanceof Element)return e.fire("beforeUpdate"),n=/innerHTML|innerText|textContent|type|src/,x.iterate(t,function(t,r){switch(!0){case n.test(r):e[r]=t;break;case r==="class":t.isEmpty()?e.removeClass("*"):e.addClass(t);break;case r.indexOf("data-")===0:d.data(e,r.replace("data-",""),t);break;case"id":var i=w.listeners;typeof i[e.id]!="undefined"&&(i[r]=x.clone(i[e.id]),delete i[e.id]);default:e.attr(r,t)}}),e.fire("afterUpdate"),e;throw Error(m.error.invalidArguments)},val:function(e,t){var n=null,r;e=x.object(e);if(e instanceof Array)return e.each(function(e){d.val(e,t)});if(e instanceof Element){switch(!0){case typeof t=="undefined":switch(!0){case/radio|checkbox/gi.test(e.type):if(e.name.isEmpty())throw Error(m.error.expectedProperty);r=s("input[name='"+e.name+"']"),r.each(function(e){if(n!==null)return;e.checked&&(n=e.value)});break;case/select/gi.test(e.type):n=e.options[e.selectedIndex].value;break;default:n=typeof e.value!="undefined"?e.value:d.text(e)}break;default:t=String(t),e.fire("beforeValue");switch(!0){case/radio|checkbox/gi.test(e.type):r=s("input[name='"+e.name+"']"),r.each(function(e){if(n!==null)return;e.value===t&&(e.checked=!0,n=e)});break;case/select/gi.test(e.type):f.cast(e.options).each(function(e){if(n!==null)return;e.value===t&&(e.selected=!0,n=e)});break;default:typeof e.value!="undefined"?e.value=t:d.text(e,t)}e.fire("afterValue"),n=e}return n}throw Error(m.error.invalidArguments)}},v={decode:function(e,t){try{return JSON.parse(e)}catch(n){return t!==!0&&C(n,arguments,this),undefined}},encode:function(e,t){try{return JSON.stringify(e)}catch(n){return t!==!0&&C(n,arguments,this),undefined}}},m={common:{back:"Back",cancel:"Cancel",clear:"Clear",close:"Close",cont:"Continue",create:"Create",del:"Delete",edit:"Edit",find:"Find",gen:"Generate",go:"Go",loading:"Loading",next:"Next",login:"Login",ran:"Random",reset:"Reset",save:"Save",search:"Search",submit:"Submit"},day:{0:"Sunday",1:"Monday",2:"Tuesday",3:"Wednesday",4:"Thursday",5:"Friday",6:"Saturday"},error:{databaseNotOpen:"Failed to open the Database, possibly exceeded Domain quota",databaseNotSupported:"Client does not support local database storage",databaseWarnInjection:"Possible SQL injection in database transaction, use the &#63; placeholder",elementNotCreated:"Could not create the Element",elementNotFound:"Could not find the Element",expectedArray:"Expected an Array",expectedArrayObject:"Expected an Array or Object",expectedBoolean:"Expected a Boolean value",expectedNumber:"Expected a Number",expectedProperty:"Expected a property, and it was not set",expectedObject:"Expected an Object",invalidArguments:"One or more arguments is invalid",invalidDate:"Invalid Date",invalidFields:"The following required fields are invalid: ",notAvailable:"Requested method is not available",propertyNotFound:"Could not find the requested property",serverError:"Server error has occurred",serverForbidden:"Forbidden to access URI",serverInvalidMethod:"Method not allowed",serverUnauthorized:"Authorization required to access URI"},month:{0:"January",1:"February",2:"March",3:"April",4:"May",5:"June",6:"July",7:"August",8:"September",9:"October",10:"November",11:"December"}},g={clear:function(t){return typeof t=="undefined"&&(t="all"),s.un(e,"message","message",t)},send:function(e,t){try{e.postMessage(t,"*")}catch(n){C(n,arguments,this)}return e},recv:function(t,n){return typeof n=="undefined"&&(n="all"),s.on(e,"message",t,"message",e,n)}},y={enabled:!1,log:!1,diff:{x:null,y:null},pos:{x:null,y:null},prev:{x:null,y:null},track:function(e){var n=o.mouse;switch(!0){case typeof e=="object":var r=t[c.ie&&c.version<9?"documentElement":"body"],i=e.pageX?e.pageX:r.scrollLeft+e.clientX,u=e.pageY?e.pageY:r.scrollTop+e.clientY,a=!1;n.pos.x!==i&&(a=!0),s.mouse.prev.x=n.prev.x=Number(n.pos.x),s.mouse.pos.x=n.pos.x=i,s.mouse.diff.x=n.diff.x=n.pos.x-n.prev.x,n.pos.y!==u&&(a=!0),s.mouse.prev.y=n.prev.y=Number(n.pos.y),s.mouse.pos.y=n.pos.y=u,s.mouse.diff.y=n.diff.y=n.pos.y-n.prev.y,a&&n.log&&x.log(n.pos.x+" ["+n.diff.x+"], "+n.pos.y+" ["+n.diff.y+"]");break;case typeof e=="boolean":e?w.add(t,"mousemove",o.mouse.track):w.remove(t,"mousemove"),s.mouse.enabled=n.enabled=e}return n}},b={diff:function(e){if(isNaN(e)||isNaN(this))throw Error(m.error.expectedNumber);return Math.abs(this-e)},even:function(e){return e%2===0},format:function(e,t,n){if(isNaN(e))throw Error(m.error.expectedNumber);e=e.toString(),t=t||",",n=n||3;var r=e.indexOf(".")>-1?"."+e.replace(/.*\./,""):"",i=e.replace(/\..*/,"").split("").reverse(),s=Math.floor(i.length/n),o=1,u,a;for(a=0;a<s;a++)u=o===1?n:n*o+(o===2?1:o-1),i.splice(u,0,t),o++;return i=i.reverse().join(""),i.charAt(0)===t&&(i=i.substring(1)),i+r},half:function(e,t){return typeof t!="undefined"?e/t===.5:e/2},odd:function(e){return e%2!==0},parse:function(e){return String(e).indexOf(".")<0?parseInt(e):parseFloat(e)},round:function(e,t){return String(e).indexOf(".")<0?e:(/down|up/.test(t)||(t="down"),Math[t==="down"?"floor":"ceil"](e))}},w={listeners:{},log:!1,add:function(e,t,n,r,i,s){e=x.object(e),i=i||o,s=s||o.state.current;if(e instanceof Array)return e.each(function(e){w.add(e,t,n,r,i,s)});t=t.explode();if(typeof r=="undefined"||!/\w/.test(r))r=x.guid(!0);var u=null,a=w.listeners,f=this.id(e),l=!1,c=o.state.current,h=/body|document|window/i,p=/click|key|mousedown|mouseup/i,d,v,g;if(typeof f=="undefined"||typeof t=="undefined"||typeof n!="function")throw Error(m.error.invalidArguments);return t.each(function(t){l=!1,typeof a[f]=="undefined"&&(a[f]={}),typeof a[f][t]=="undefined"&&(l=!0)&&(a[f][t]={}),typeof a[f][t][s]=="undefined"&&(a[f][t][s]={});if(l){switch(!0){case h.test(f):case!/\//g.test(f)&&f!=="abaaso":u=e;break;default:u=null}u!==null&&typeof u!="undefined"&&t.toLowerCase()!=="afterjsonp"&&(h.test(f)||typeof u.listeners=="function")&&(v=typeof u.addEventListener=="function",g=typeof u.attachEvent=="object"||v,g&&u[v?"addEventListener":"attachEvent"]((v?"":"on")+t,function(n){!h.test(n.type)&&!p.test(n.type)&&x.stop(n),w.fire(e,t,n)},!1))}d={fn:n,scope:i},a[f][t][s][r]=d}),e},id:function(n){var r;switch(!0){case n===o:r="abaaso";break;case n===e:r="window";break;case n===t:r="document";break;case n===t.body:r="body";break;default:r=typeof n.id!="undefined"?n.id:typeof n.toString=="function"?n.toString():n}return r},fire:function(e,t,n){e=x.object(e);if(e instanceof Array)return e.each(function(r){w.fire(e[r],t,n)});t=t.explode();var r=this.id(e),i=n,u=o.state.current,a=s.observer.log||o.observer.log,f=this,l,c,h;if(typeof r=="undefined"||String(r).isEmpty()||typeof e=="undefined"||typeof t=="undefined")throw Error(m.error.invalidArguments);return t.each(function(t){a&&x.log(r+" fired "+t),h=f.list(e,t),c=h.all,typeof c!="undefined"&&x.iterate(c,function(e,t){e.fn.call(e.scope,i)}),u!=="all"&&(c=h[u],typeof c!="undefined"&&x.iterate(c,function(e,t){e.fn.call(e.scope,i)}))}),e},list:function(e,t){e=x.object(e);var n=this.listeners,r=this.id(e),i;switch(!0){case typeof n[r]=="undefined"&&typeof t=="undefined":i={};break;case typeof n[r]!="undefined"&&(typeof t=="undefined"||String(t).isEmpty()):i=n[r];break;case typeof n[r]!="undefined"&&typeof n[r][t]!="undefined":i=n[r][t];break;default:i={}}return i},once:function(e,t,n,r,i,s){var u=r||x.genId();return e=x.object(e),i=i||o,s=s||o.state.current,e instanceof Array?e.each(function(e){w.once(e,t,n,r,i,s)}):(w.add(e,t,function(r){w.remove(e,t,u,s),n.call(i,r)},u,i,s),e)},remove:function(e,t,n,r){e=x.object(e),r=r||o.state.current;if(e instanceof Array)return e.each(function(e){w.remove(e,t,n,r)});var i=null,s=w.listeners,u=this.id(e);switch(!0){case typeof u=="undefined":case typeof s[u]=="undefined":return e}return typeof t=="undefined"?delete s[u]:t.explode().each(function(t){if(typeof s[u][t]=="undefined")return e;typeof n=="undefined"?s[u][t][r]={}:delete s[u][t][r][n]}),e}},E={bang:/\#|\!\//g,regex:new RegExp,word:/\w/,routes:{error:function(){x.error(m.error.invalidArguments),o.route.initial!==null&&E.hash(o.route.initial)}},del:function(e){if(e!=="error"&&E.routes.hasOwnProperty(e))return o.route.initial===e&&(o.route.initial=null),delete E.routes[e];throw Error(m.error.invalidArguments)},hash:function(e){var n="";return typeof e=="undefined"?n=t.location.hash.replace(E.bang,""):(n=e.replace(E.bang,""),t.location.hash="!/"+n),n},init:function(){var e=t.location.hash;return E.word.test(e)?E.load(e):E.hash(o.route.initial!==null?o.route.initial:f.cast(E.routes,!0).remove("error").first()),e.replace(E.bang,"")},list:function(){return f.cast(E.routes,!0)},load:function(e){var t="error";return e=e.replace(E.bang,""),typeof E.routes[e]!="undefined"?t=e:x.iterate(E.routes,function(n,r){if(x.compile(E.regex,"^"+r+"$","i")&&E.regex.test(e))return!(t=r)}),E.routes[t](e),!0},set:function(e,t){if(typeof e!="string"||e.isEmpty()||typeof t!="function")throw Error(m.error.invalidArguments);return E.routes[e]=t,!0}},S={capitalize:function(e){return e=S.trim(e),e.charAt(0).toUpperCase()+e.slice(1)},escape:function(e){return e.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")},explode:function(e,t){if(typeof t=="undefined"||t.toString()==="")t=",";return S.trim(e).split(new RegExp("\\s*"+t+"\\s*"))},hyphenate:function(e){return S.trim(e).replace(/\s+/g,"-")},singular:function(e){return/s$/.test(e)?e.slice(0,-1):e},toCamelCase:function(e){var t=S.trim(e).toLowerCase().split(" "),n=[],r=0,i,s;return t.each(function(e){e=S.trim(e);if(e.isEmpty())return;n.push(r++===0?e:S.capitalize(e))}),n.join("")},trim:function(e){return e.replace(/^\s+|\s+$/g,"")},uncapitalize:function(e){return e=S.trim(e),e.charAt(0).toLowerCase()+e.slice(1)}},x={timer:{},$:function(e,n){if(String(e).indexOf("?")>-1)return undefined;var r=[],i=[],o,u;e=e.trim(),n=n===!0,e.indexOf(",")>-1&&(e=e.explode());if(e instanceof Array)return e.each(function(e){i.push(s(e,n))}),i.each(function(e){r=r.concat(e)}),r;switch(!0){case/\s|>/.test(e):u=e.split(" ").filter(function(e){if(e.trim()!==""&&e!==">")return!0}).last(),o=t[u.indexOf("#")>-1&&u.indexOf(":")===-1?"querySelector":"querySelectorAll"](e);break;case e.indexOf("#")===0&&e.indexOf(":")===-1:o=isNaN(e.charAt(1))?t.querySelector(e):t.getElementById(e.substring(1));break;case e.indexOf("#")>-1&&e.indexOf(":")===-1:o=t.querySelector(e);break;default:o=t.querySelectorAll(e)}return typeof o!="undefined"&&o!==null&&!(o instanceof Element)&&!n&&(o=f.cast(o)),o===null&&(o=undefined),o},alias:function(e,t){var n=e,r=t;return x.iterate(r,function(e,t){var i,s;switch(!0){case!(e instanceof RegExp)&&typeof e=="function":n[t]=e.bind(n[t]);break;case!(e instanceof RegExp)&&!(e instanceof Array)&&e instanceof Object:typeof n[t]=="undefined"&&(n[t]={}),x.alias(n[t],r[t]);break;default:i=function(){return r[t]},s=function(e){r[t]=e},x.property(n,t,{enumerable:!0,get:i,set:s,value:r[t]})}}),e},clone:function(e){var t;switch(!0){case e instanceof Array:return[].concat(e);case typeof e=="boolean":return Boolean(e);case typeof e=="function":return e;case typeof e=="number":return Number(e);case typeof e=="string":return String(e);case!c.ie&&e instanceof Document:return N.decode(N.encode(e));case e instanceof Object:return t=v.decode(v.encode(e)),typeof t!="undefined"&&(e.hasOwnProperty("constructor")&&(t.constructor=e.constructor),e.hasOwnProperty("prototype")&&(t.prototype=e.prototype)),t;default:return e}},coerce:function(e){var t=x.clone(e),n;switch(!0){case/^\d$/.test(t):t=b.parse(t);break;case/^(true|false)$/i.test(t):t=/true/i.test(t);break;case t==="undefined":t=undefined;break;case t==="null":t=null;break;case(n=v.decode(t,!0))&&typeof n!="undefined":t=n}return t},compile:function(e,t,n){return e.compile(t,n),!0},define:function(e,t,n){e=e.split("."),typeof n=="undefined"&&(n=this),typeof t=="undefined"&&(t=null),n===s&&(n=o);var r=n,i=e.length;return e.each(function(n,s){var o=s+1<i&&!isNaN(parseInt(e[s+1])),u=t;isNaN(parseInt(n))||(n=parseInt(n));switch(!0){case typeof r[n]=="undefined":r[n]=o?[]:{};break;case r[n]instanceof Object&&o:r[n]=f.cast(r[n]);break;case r[n]instanceof Object:break;case r[n]instanceof Array&&!o:r[n]=r[n].toObject();break;default:r[n]={}}s+1===i?r[n]=u:r=r[n]}),n},defer:function(e,t,n){t=t||10,n=n||x.guid(!0);var r=function(){delete x.timer[n],e()};return x.timer[n]=setTimeout(r,t),undefined},domId:function(e){return"a"+e.replace(/-/g,"").slice(1)},error:function(e,t,n,r){var i;return typeof e!="undefined"&&(r=r===!0,i={arguments:t,message:typeof e.message!="undefined"?e.message:e,number:typeof e.number!="undefined"?e.number&65535:undefined,scope:n,stack:typeof e.stack=="string"?e.stack:undefined,timestamp:(new Date).toUTCString(),type:typeof e.type!="undefined"?e.type:"TypeError"},typeof console!="undefined"&&console[r?"warn":"error"](i.message),s.error.log.push(i),s.fire("error",i)),undefined},extend:function(e,t){var n,r;if(typeof e=="undefined")throw Error(m.error.invalidArguments);typeof t=="undefined"&&(t={});switch(!0){case typeof Object.create=="function":n=Object.create(e);break;default:r=function(){},r.prototype=e,n=new r}return x.merge(n,t),n},genId:function(e){var t;switch(!0){case e instanceof Array:case e instanceof String:case typeof e=="string":case typeof e!="undefined"&&typeof e.id!="undefined"&&e.id!=="":return e}do t=x.domId(x.guid(!0));while(typeof s("#"+t)!="undefined");return typeof e=="object"?(e.id=t,e):t},guid:function(e){e=e===!0;var t=function(){return((1+Math.random())*65536|0).toString(16).substring(1)},n;return n=(t()+t()+"-"+t()+"-4"+t().substr(0,3)+"-"+t()+"-"+t()+t()+t()).toLowerCase(),e&&(n=n.replace(/-/gi,"")),n},iterate:function(e,t){var n,r;if(typeof t!="function")throw Error(m.error.invalidArguments);for(n in e)if(Object.prototype.hasOwnProperty.call(e,n)){r=t.call(e,e[n],n);if(r===!1)break}return e},loading:function(e){var t=o.loading;e=x.object(e);if(e instanceof Array)return e.each(function(e){x.loading(e)});if(t.url===null)throw Error(m.error.elementNotFound);if(typeof e=="undefined")throw Error(m.error.invalidArguments);return typeof t.image=="undefined"&&(t.image=new Image,t.image.src=t.url),e.clear(),e.create("div",{"class":"loading"}).create("img",{alt:m.common.loading,src:t.image.src}),e},log:function(e){try{console.log("["+(new Date).toLocaleTimeString()+"] "+e)}catch(t){C(t,arguments,this)}return undefined},merge:function(e,t){return x.iterate(t,function(t,n){e[n]=x.clone(t)}),e},module:function(e,t){if(typeof s[e]!="undefined"||typeof o[e]!="undefined"||!t instanceof Object)throw Error(m.error.invalidArguments);return o[e]=t,typeof t=="function"?s[e]=!c.ie||c.version>8?o[e].bind(s[e]):o[e]:(s[e]={},x.alias(s[e],o[e])),s[e]},object:function(e){return typeof e=="object"?e:e.toString().charAt(0)==="#"?s(e):e},property:function(e,t,n){if(n instanceof Object){var r;return r=(!c.ie||c.version>8)&&typeof Object.defineProperty=="function",r&&typeof n.value!="undefined"&&typeof n.get!="undefined"&&delete n.value,r?Object.defineProperty(e,t,n):e[t]=n.value,e}throw Error(m.error.invalidArguments)},proto:function(e,t){var n,r={array:{add:function(e){return f.add(this,e)},addClass:function(e){return this.each(function(t){t.addClass(e)})},after:function(e,t){var n=[];return this.each(function(r){n.push(r.after(e,t))}),n},append:function(e,t){var n=[];return this.each(function(r){n.push(r.append(e,t))}),n},attr:function(e,t){var n=[];return this.each(function(r){n.push(r.attr(e,t))}),n},before:function(e,t){var n=[];return this.each(function(r){n.push(r.before(e,t))}),n},clear:function(e){return this.each(function(e){e.clear()})},clone:function(){return x.clone(this)},contains:function(e){return f.contains(this,e)},create:function(e,t,n){var r=[];return this.each(function(i){r.push(i.create(e,t,n))}),r},css:function(e,t){return this.each(function(n){n.css(e,t)})},data:function(e,t){var n=[];return this.each(function(r){n.push(r.data(e,t))}),n},diff:function(e){return f.diff(this,e)},disable:function(){return this.each(function(e){e.disable()})},destroy:function(){return this.each(function(e){e.destroy()}),[]},each:function(e){return f.each(this,e)},enable:function(){return this.each(function(e){e.enable()})},find:function(e){var t=[];return this.each(function(n){n.find(e).each(function(e){t.contains(e)||t.push(e)})}),t},fire:function(e,t){return this.each(function(n){n.fire(e,t)})},first:function(){return f.first(this)},get:function(e,t){return this.each(function(n){n.get(e,t)}),[]},has:function(e){var t=[];return this.each(function(n){t.push(n.has(e))}),t},hasClass:function(e){var t=[];return this.each(function(n){t.push(n.hasClass(e))}),t},hide:function(){return this.each(function(e){e.hide()})},html:function(e){if(typeof e!="undefined")return this.each(function(t){t.html(e)});var t=[];return this.each(function(e){t.push(e.html())}),t},index:function(e){return f.index(this,e)},indexed:function(){return f.indexed(this)},intersect:function(e){return f.intersect(this,e)},is:function(e){var t=[];return this.each(function(n){t.push(n.is(e))}),t},isAlphaNum:function(){var e=[];return this.each(function(t){e.push(t.isAlphaNum())}),e},isBoolean:function(){var e=[];return this.each(function(t){e.push(t.isBoolean())}),e},isChecked:function(){var e=[];return this.each(function(t){e.push(t.isChecked())}),e},isDate:function(){var e=[];return this.each(function(t){e.push(t.isDate())}),e},isDisabled:function(){var e=[];return this.each(function(t){e.push(t.isDisabled())}),e},isDomain:function(){var e=[];return this.each(function(t){e.push(t.isDomain())}),e},isEmail:function(){var e=[];return this.each(function(t){e.push(t.isEmail())}),e},isEmpty:function(){var e=[];return this.each(function(t){e.push(t.isEmpty())}),e},isHidden:function(){var e=[];return this.each(function(t){e.push(t.isHidden())}),e},isIP:function(){var e=[];return this.each(function(t){e.push(t.isIP())}),e},isInt:function(){var e=[];return this.each(function(t){e.push(t.isInt())}),e},isNumber:function(){var e=[];return this.each(function(t){e.push(t.isNumber())}),e},isPhone:function(){var e=[];return this.each(function(t){e.push(t.isPhone())}),e},isString:function(){var e=[];return this.each(function(t){e.push(t.isString())}),e},keys:function(){return f.keys(this)},last:function(e){return f.last(this)},listeners:function(e){var t=[];return this.each(function(n){t=t.concat(n.listeners(e))}),t},loading:function(){return this.each(function(e){e.loading()})},on:function(e,t,n,r,i){return this.each(function(s){s.on(e,t,n,typeof r!="undefined"?r:s,i)})},once:function(e,t,n,r,i){return this.each(function(s){s.once(e,t,n,typeof r!="undefined"?r:s,i)})},position:function(){var e=[];return this.each(function(t){e.push(t.position())}),e},prepend:function(e,t){var n=[];return this.each(function(r){n.push(r.prepend(e,t))}),n},range:function(e,t){return f.range(this,e,t)},remove:function(e,t){return f.remove(this,e,t)},removeClass:function(e){return this.each(function(t){t.removeClass(e)})},show:function(){return this.each(function(e){e.show()})},size:function(){var e=[];return this.each(function(t){e.push(t.size())}),e},text:function(e){return this.each(function(t){typeof t!="object"&&(t=x.object(t)),typeof t.text=="function"&&t.text(e)})},tpl:function(e){return this.each(function(t){t.tpl(e)})},total:function(){return f.total(this)},toObject:function(){return f.toObject(this)},un:function(e,t,n){return this.each(function(r){r.un(e,t,n)})},update:function(e){return this.each(function(t){d.update(t,e)})},val:function(e){var t=[],n=null,r=!0;return this.each(function(i){n!==null&&(r=n===i.type),n=i.type,typeof i.val=="function"&&t.push(i.val(e))}),r?t[0]:t},validate:function(){var e=[];return this.each(function(t){e.push(t.validate())}),e}},element:{addClass:function(e){return x.genId(this),d.klass(this,e,!0)},after:function(e,t){return x.genId(this),d.create(e,t,this,"after")},append:function(e,t){return x.genId(this),d.create(e,t,this,"last")},attr:function(e,t){return x.genId(this),d.attr(this,e,t)},before:function(e,t){return x.genId(this),d.create(e,t,this,"before")},clear:function(){return x.genId(this),d.clear(this)},create:function(e,t,n){return x.genId(this),d.create(e,t,this,n)},css:function(e,t){var n;return x.genId(this),!c.chrome&&(n=e.indexOf("-"))&&n>-1&&(e=e.replace("-",""),e=e.slice(0,n)+e.charAt(n).toUpperCase()+e.slice(n+1,e.length)),this.style[e]=t,this},data:function(e,t){return x.genId(this),d.data(this,e,t)},destroy:function(){return d.destroy(this)},disable:function(){return d.disable(this)},enable:function(){return d.enable(this)},find:function(e){return x.genId(this),d.find(this,e)},fire:function(e,t){return x.genId(this),s.fire.call(this,e,t)},genId:function(){return x.genId(this)},get:function(e,t){this.fire("beforeGet");var n=l.get(e),r=this;return n?this.html(n.response).fire("afterGet"):e.get(function(e){r.html(e).fire("afterGet")},function(e){r.fire("failedGet",{response:c.parse(e),xhr:e})},t),this},has:function(e){return x.genId(this),d.has(this,e)},hasClass:function(e){return x.genId(this),d.hasClass(this,e)},hide:function(){return x.genId(this),d.hide(this)},html:function(e){return x.genId(this),typeof e=="undefined"?this.innerHTML:this.update({innerHTML:e})},is:function(e){return x.genId(this),d.is(this,e)},isAlphaNum:function(){return this.nodeName==="FORM"?!1:T.test({alphanum:typeof this.value!="undefined"?this.value:d.text(this)}).pass},isBoolean:function(){return this.nodeName==="FORM"?!1:T.test({"boolean":typeof this.value!="undefined"?this.value:d.text(this)}).pass},isChecked:function(){return this.nodeName!=="INPUT"?!1:this.attr("checked")},isDate:function(){return this.nodeName==="FORM"?!1:typeof this.value!="undefined"?this.value.isDate():d.text(this).isDate()},isDisabled:function(){return this.nodeName!=="INPUT"?!1:this.attr("disabled")},isDomain:function(){return this.nodeName==="FORM"?!1:typeof this.value!="undefined"?this.value.isDomain():d.text(this).isDomain()},isEmail:function(){return this.nodeName==="FORM"?!1:typeof this.value!="undefined"?this.value.isEmail():d.text(this).isEmail()},isEmpty:function(){return this.nodeName==="FORM"?!1:typeof this.value!="undefined"?this.value.isEmpty():d.text(this).isEmpty()},isHidden:function(e){return x.genId(this),d.hidden(this)},isIP:function(){return this.nodeName==="FORM"?!1:typeof this.value!="undefined"?this.value.isIP():d.text(this).isIP()},isInt:function(){return this.nodeName==="FORM"?!1:typeof this.value!="undefined"?this.value.isInt():d.text(this).isInt()},isNumber:function(){return this.nodeName==="FORM"?!1:typeof this.value!="undefined"?this.value.isNumber():d.text(this).isNumber()},isPhone:function(){return this.nodeName==="FORM"?!1:typeof this.value!="undefined"?this.value.isPhone():d.text(this).isPhone()},isString:function(){return this.nodeName==="FORM"?!1:typeof this.value!="undefined"?this.value.isString():d.text(this).isString()},jsonp:function(e,t,n){var r=this,i=t,s;return s=function(e){var t=r,n=e,s=i,o,u,a;try{typeof s!="undefined"?(s=s.replace(/]|'|"/g,"").replace(/\./g,"[").split("["),s.each(function(e){n=n[isNaN(e)?e:parseInt(e)];if(typeof n=="undefined")throw Error(m.error.propertyNotFound)}),a=n):a=e}catch(f){a=m.error.serverError,C(f,arguments,this)}t.text(a)},c.jsonp(e,s,function(){r.text(m.error.serverError)},n),this},listeners:function(e){return x.genId(this),s.listeners.call(this,e)},loading:function(){return x.loading(this)},on:function(e,t,n,r,i){return x.genId(this),s.on.call(this,e,t,n,r,i)},once:function(e,t,n,r,i){return x.genId(this),s.once.call(this,e,t,n,r,i)},prepend:function(e,t){return x.genId(this),d.create(e,t,this,"first")},prependChild:function(e){return x.genId(this),d.prependChild(this,e)},position:function(){return x.genId(this),d.position(this)},removeClass:function(e){return x.genId(this),d.klass(this,e,!1)},show:function(){return x.genId(this),d.show(this)},size:function(){return x.genId(this),d.size(this)},text:function(e){return x.genId(this),d.text(this,e)},tpl:function(e){return x.tpl(e,this)},un:function(e,t,n){return x.genId(this),s.un.call(this,e,t,n)},update:function(e){return x.genId(this),d.update(this,e)},val:function(e){return x.genId(this),d.val(this,e)},validate:function(){return this.nodeName==="FORM"?T.test(this):typeof this.value!="undefined"?!this.value.isEmpty():!d.text(this).isEmpty()}},"function":{reflect:function(){return x.reflect(this)}},number:{diff:function(e){return b.diff.call(this,e)},fire:function(e,t){return s.fire.call(this.toString(),e,t),this},format:function(e,t){return b.format(this,e,t)},half:function(e){return b.half(this,e)},isEven:function(){return b.even(this)},isOdd:function(){return b.odd(this)},listeners:function(e){return s.listeners.call(this.toString(),e)},on:function(e,t,n,r,i){return s.on.call(this.toString(),e,t,n,r||this,i),this},once:function(e,t,n,r,i){return s.once.call(this.toString(),e,t,n,r||this,i),this},roundDown:function(){return b.round(this,"down")},roundUp:function(){return b.round(this,"up")},un:function(e,t,n){return s.un.call(this.toString(),e,t,n),this}},string:{allows:function(e){return c.allows(this,e)},capitalize:function(){return S.capitalize(this)},del:function(e,t,n){return c.request(this,"DELETE",e,t,null,n)},escape:function(){return S.escape(this)},expire:function(e){return l.expire(this,e)},explode:function(e){return S.explode(this,e)},fire:function(e,t){return s.fire.call(this,e,t)},get:function(e,t,n){return c.request(this,"GET",e,t,null,n)},headers:function(e,t){return c.request(this,"HEAD",e,t)},hyphenate:function(){return S.hyphenate(this)},isAlphaNum:function(){return T.test({alphanum:this}).pass},isBoolean:function(){return T.test({"boolean":this}).pass},isDate:function(){return T.test({date:this}).pass},isDomain:function(){return T.test({domain:this}).pass},isEmail:function(){return T.test({email:this}).pass},isEmpty:function(){return!T.test({notEmpty:this}).pass},isIP:function(){return T.test({ip:this}).pass},isInt:function(){return T.test({integer:this}).pass},isNumber:function(){return T.test({number:this}).pass},isPhone:function(){return T.test({phone:this}).pass},isString:function(){return T.test({string:this}).pass},jsonp:function(e,t,n){return c.jsonp(this,e,t,n)},listeners:function(e){return s.listeners.call(this,e)},post:function(e,t,n,r){return c.request(this,"POST",e,t,n,r)},put:function(e,t,n,r){return c.request(this,"PUT",e,t,n,r)},on:function(e,t,n,r,i){return s.on.call(this,e,t,n,r,i)},once:function(e,t,n,r,i){return s.once.call(this,e,t,n,r,i)},options:function(e,t){return c.request(this,"OPTIONS",e,t)},permissions:function(){return c.permissions(this)},singular:function(){return S.singular(this)},toCamelCase:function(){return S.toCamelCase(this)},trim:function(){return S.trim(this)},un:function(e,t,n){return s.un.call(this,e,t,n)},uncapitalize:function(){return S.uncapitalize(this)}}};return x.iterate(r[t],function(t,n){x.property(e.prototype,n,{value:t})}),e},queryString:function(e){e=e||".*";var t={},r=n.search.isEmpty()?null:n.search.replace("?",""),i;return r!==null&&(r=r.split("&"),r.each(function(e){i=e.split("=");if(i[0].isEmpty())return;switch(!0){case typeof i[1]=="undefined":case i[1].isEmpty():i[1]="";break;case i[1].isNumber():i[1]=Number(i[1]);break;case i[1].isBoolean():i[1]=i[1]==="true"}switch(!0){case typeof t[i[0]]=="undefined":t[i[0]]=i[1];break;case!(t[i[0]]instanceof Array):t[i[0]]=[t[i[0]]];default:t[i[0]].push(i[1])}})),t},reflect:function(e){return typeof e=="undefined"&&(e=this),typeof e=="undefined"&&(e=s),e=e.toString().match(/function\s+\w*\s*\((.*?)\)/)[1],e!==""?e.explode():[]},repeat:function(e,t,n){t=t||10,n=n||x.guid(!0);var r=function(e,t,n){var r=this;e()!==!1&&x.defer(function(){r.call(r,e,t,n)},t)};return r.call(r,e,t,n),n},stop:function(e){return typeof e.cancelBubble!="undefined"&&(e.cancelBubble=!0),typeof e.preventDefault=="function"&&e.preventDefault(),typeof e.stopPropagation=="function"&&e.stopPropagation(),e},tpl:function(e,n){var r;switch(!0){case typeof e!="object":case!/object|undefined/.test(typeof n)&&typeof (n=n.charAt(0)==="#"?s(n):s(n)[0])=="undefined":throw Error(m.error.invalidArguments)}typeof n=="undefined"&&(n=s("body")[0]),r=t.createDocumentFragment();switch(!0){case e instanceof Array:e.each(function(e,t){d.create(f.cast(e,!0)[0],r).html(f.cast(e)[0])});break;default:x.iterate(e,function(e,t){switch(!0){case typeof e=="string":d.create(t,r).html(e);break;case e instanceof Array:case e instanceof Object:x.tpl(e,d.create(t,r))}})}return n.appendChild(r),f.last(n.childNodes)},walk:function(e,t){return t.replace(/\]$/,"").replace(/\]/g,".").split(/\.|\[/).each(function(t){e=e[t]}),e}},T={pattern:{alphanum:/^[a-zA-Z0-9]*$/,"boolean":/^(0|1|true|false)?$/,domain:/^[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&amp;:\/~\+#]*[\w\-\@?^=%&amp;\/~\+#])?/,email:/^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/,ip:/^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/,integer:/(^-?\d\d*$)/,notEmpty:/\w{1,}/,number:/(^-?\d\d*\.\d*$)|(^-?\d\d*$)|(^-?\.\d\d*$)/,phone:/^\([1-9]\d{2}\)\s?\d{3}\-\d{4}$/,string:/\w/},test:function(e){var t=!1,n=[],r={},i=null,o=[],u=[],a=[],f=[],l,c,h,p,d;return typeof e.nodeName!="undefined"&&e.nodeName==="FORM"?(e.id.isEmpty()&&e.genId(),a=s("#"+e.id+" input"),f=s("#"+e.id+" select"),a.length>0&&(u=u.concat(a)),f.length>0&&(u=u.concat(f)),u.each(function(e){var r={},i,s,o;i=T.pattern[e.nodeName.toLowerCase()]?T.pattern[e.nodeName.toLowerCase()]:!e.id.isEmpty()&&T.pattern[e.id.toLowerCase()]?T.pattern[e.id.toLowerCase()]:"notEmpty",s=e.val(),s===null&&(s=""),r[i]=s,o=T.test(r),o.pass||(n.push({element:e,test:i,value:s}),t=!0)})):x.iterate(e,function(e,r){if(typeof r=="undefined"||typeof e=="undefined"){n.push({test:r,value:e}),t=!0;return}i=e.charAt(0)==="#"?typeof s(e)!="undefined"?s(e).val():"":e;switch(r){case"date":isNaN((new Date(i)).getYear())&&(n.push({test:r,value:i}),t=!0);break;case"domain":T.pattern.domain.test(i.replace(/.*\/\//,""))||(n.push({test:r,value:i}),t=!0);break;case"domainip":if(!T.pattern.domain.test(i.replace(/.*\/\//,""))||!T.pattern.ip.test(i))n.push({test:r,value:i}),t=!0;break;default:c=typeof T.pattern[r]!="undefined"?T.pattern[r]:r,c.test(i)||(n.push({test:r,value:i}),t=!0)}}),{pass:!t,invalid:n}}},N={decode:function(e){try{if(typeof e!="string"||e.isEmpty())throw Error(m.error.invalidArguments);var t;return c.ie?(t=new ActiveXObject("Microsoft.XMLDOM"),t.async="false",t.loadXML(e)):t=(new DOMParser).parseFromString(e,"text/xml"),t}catch(n){return C(n,arguments,this),undefined}},encode:function(e,t){try{if(typeof e=="undefined")throw Error(m.error.invalidArguments);t=t!==!1;var n=t?"<xml>":"",r=arguments[2]!==!1,i,s;e!==null&&typeof e.xml!="undefined"&&(e=e.xml),e instanceof Document&&(e=(new XMLSerializer).serializeToString(e)),i=function(e,t){var n="<n>v</n>";return/\&|\<|\>|\"|\'|\t|\r|\n|\@|\$/g.test(t)&&(n=n.replace(/v/,"<![CDATA[v]]>")),n.replace(/n/g,e).replace(/v/,t)};switch(!0){case typeof e=="boolean":case typeof e=="number":case typeof e=="string":n+=i("item",e);break;case typeof e=="object":x.iterate(e,function(e,t){n+=N.encode(e,typeof e=="object",!1).replace(/item|xml/g,isNaN(t)?t:"item")})}return n+=t?"</xml>":"",r&&(n='<?xml version="1.0" encoding="UTF8"?>'+n),n}catch(o){return C(o,arguments,this),undefined}}},C=x.error,a=function(){var r,u;typeof o.bootstrap=="function"&&delete o.bootstrap,r=function(e){var t=[];w.remove(e),e.childNodes.length>0&&(t=f.cast(e.childNodes)),t.length>0&&t.each(function(e){r(e)})},u=function(e){if(/complete|loaded/.test(t.readyState))return typeof o.init=="function"&&o.init(),!1},typeof Array.prototype.filter=="undefined"&&(Array.prototype.filter=function(e){if(this===void 0||this===null||typeof e!="function")throw Error(m.error.invalidArguments);var t=null,n=Object(this),r=n.length>>>0,i=[],s=arguments[1],o=null;for(t=0;t<r;t++)t in n&&(o=n[t],e.call(s,o,t,n)&&i.push(o));return i}),typeof Array.prototype.forEach=="undefined"&&(Array.prototype.forEach=function(e,t){if(this===null||typeof e!="function")throw Error(m.error.invalidArguments);var n,r=0,i=Object(this),s=i.length>>>0;t&&(n=t);while(r<s){var o;r in i&&(o=i[r],e.call(n,o,r,i)),r++}}),typeof Array.prototype.indexOf=="undefined"&&(Array.prototype.indexOf=function(e,t){for(var n=t||0,r=this.length;n<r;n++)if(this[n]===e)return n;return-1}),typeof Function.prototype.bind=="undefined"&&(Function.prototype.bind=function(e){var t=this,n=Array.prototype.slice,r=n.call(arguments,1);return function(){return t.apply(e,r.concat(n.call(arguments)))}}),o.client.size=c.size(),c.version(),c.mobile(),c.tablet();if(c.ie&&c.version<8)return;i&&delete o.cookie,s=o.$.bind(s),x.alias(s,o),delete s.$,delete s.bootstrap,delete s.callback,delete s.data,delete s.init,delete s.loading,o.route.initial=null,s.loading=o.loading.create.bind(s.loading),s.fire=o.fire,s.on=o.on,s.once=o.once,s.un=o.un,s.listeners=o.listeners,o.state._current=o.state.current="initial",s.state._current=s.state.current=o.state.current;if(!i)switch(!0){case typeof e.$=="undefined"||e.$===null:e.$=s;break;default:e.a$=s,o.aliased="a$"}x.proto(Array,"array"),typeof Element!="undefined"&&x.proto(Element,"element"),typeof HTMLDocument!="undefined"&&x.proto(HTMLDocument,"element"),x.proto(Function,"function"),x.proto(Number,"number"),x.proto(String,"string"),o.constructor=o,s.error.log=o.error.log=[],s.on(e,"error",function(e){s.fire("error",e)},"error",e,"all"),i||(s.on(e,"hashchange",function(){s.fire("beforeHash, hash, afterHash",n.hash)},"hash",e,"all"),s.on(e,"resize",function(){s.client.size=o.client.size=c.size(),s.fire("resize",o.client.size)},"resize",e,"all"),s.on(e,"load",function(){s.fire("render").un("render")}),s.on(e,"DOMNodeInserted",function(e){var t=e.target;typeof t.id!="undefined"&&t.id.isEmpty()&&(x.genId(t),t.parentNode instanceof Element&&t.parentNode.fire("afterCreate",t),s.fire("afterCreate",t))},"mutation",e,"all"),s.on(e,"DOMNodeRemoved",function(e){r(e.target)},"mutation",e,"all"),s.on("hash",function(e){(s.route.enabled||o.route.enabled)&&E.load(e)},"route",o.route,"all"));var a,l;a=function(){return this._current},l=function(e){if(e===null||typeof e!="string"||this.current===e||e.isEmpty())throw Error(m.error.invalidArguments);return o.state.previous=o.state._current,o.state._current=e,o.fire(e)};switch(!0){case!c.ie||c.version>8:x.property(o.state,"current",{enumerable:!0,get:a,set:l}),x.property(s.state,"current",{enumerable:!0,get:a,set:l});break;default:o.state.change=function(e){return l.call(o.state,e),o.state.current=e},s.state.change=function(e){return l.call(o.state,e),o.state.current=e}}s.ready=!0;switch(!0){case i:o.init();break;case typeof e.define=="function":e.define("abaaso",function(){return o.init()});break;case/complete|loaded/.test(t.readyState):o.init();break;case typeof t.addEventListener=="function":t.addEventListener("DOMContentLoaded",o.init,!1);break;case typeof t.attachEvent=="function":t.attachEvent("onreadystatechange",u);break;default:x.timer.init=x.repeat(u)}},{array:f,callback:{},client:{android:c.android,blackberry:c.blackberry,chrome:c.chrome,firefox:c.firefox,ie:c.ie,ios:c.ios,linux:c.linux,mobile:c.mobile,opera:c.opera,osx:c.osx,playbook:c.playbook,safari:c.safari,tablet:c.tablet,size:{height:0,width:0},version:0,webos:c.webos,windows:c.windows,del:function(e,t,n,r){return c.request(e,"DELETE",t,n,null,r)},get:function(e,t,n,r){return c.request(e,"GET",t,n,null,r)},headers:function(e,t,n){return c.request(e,"HEAD",t,n)},post:function(e,t,n,r,i){return c.request(e,"POST",t,n,r,i)},put:function(e,t,n,r,i){return c.request(e,"PUT",t,n,r,i)},jsonp:function(e,t,n,r){return c.jsonp(e,t,n,r)},options:function(e,t,n){return c.request(e,"OPTIONS",t,n)},permissions:c.permissions},cookie:h,data:p,element:d,json:v,label:m,loading:{create:x.loading,url:null},message:g,mouse:y,number:b,observer:{log:w.log,add:w.add,fire:w.fire,list:w.list,once:w.once,remove:w.remove},state:{_current:null,header:null,previous:null},string:S,validate:T,xml:N,$:x.$,alias:x.alias,aliased:"$",allows:c.allows,append:function(e,t,n){return n instanceof Element&&n.genId(),d.create(e,t,n,"last")},bootstrap:a,clear:d.clear,clone:x.clone,coerce:x.coerce,compile:x.compile,create:d.create,css:d.css,decode:v.decode,defer:x.defer,define:x.define,del:function(e,t,n,r){return c.request(e,"DELETE",t,n,null,r)},destroy:d.destroy,encode:v.encode,error:x.error,expire:l.clean,expires:12e4,extend:x.extend,fire:function(e,t,n){var r=typeof n!="undefined",i,u,a;i=r?e:this,u=r?t:e,a=r?n:t;if(typeof i=="undefined"||i===s)i=o;return w.fire.call(w,i,u,a)},genId:x.genId,get:function(e,t,n,r){return c.request(e,"GET",t,n,null,r)},guid:x.guid,headers:function(e,t,n){return c.request(e,"HEAD",t,n)},hidden:d.hidden,id:"abaaso",init:function(){return delete o.init,s.fire("init").un("init").fire("ready").un("ready")},iterate:x.iterate,jsonp:function(e,t,n,r){return c.jsonp(e,t,n,r)},listeners:function(e){var t=this;if(typeof t=="undefined"||t===s)t=o;return w.list.call(w,t,e)},log:x.log,merge:x.merge,module:x.module,object:x.object,on:function(e,t,n,r,i,u){var a=typeof n=="function",f,l,c,h,p,d;f=a?e:this,l=a?t:e,c=a?n:t,h=a?r:n,p=a?i:r,d=a?u:i;if(typeof f=="undefined"||f===s)f=o;return typeof p=="undefined"&&(p=f),w.add.call(w,f,l,c,h,p,d)},once:function(e,t,n,r,i,u){var a=typeof n=="function",f,l,c,h,p,d;f=a?e:this,l=a?t:e,c=a?n:t,h=a?r:n,p=a?i:r,d=a?u:i;if(typeof f=="undefined"||f===s)f=o;return typeof p=="undefined"&&(p=f),w.once.call(w,f,l,c,h,p,d)},options:function(e,t,n){return c.request(e,"OPTIONS",t,n)},permissions:c.permissions,position:d.position,post:function(e,t,n,r,i){return c.request(e,"POST",t,n,r,i)},prepend:function(e,t,n){return n instanceof Element&&n.genId(),d.create(e,t,n,"first")},property:x.property,put:function(e,t,n,r,i){return c.request(e,"PUT",t,n,r,i)},queryString:x.queryString,ready:!1,reflect:x.reflect,repeat:x.repeat,route:{enabled:!1,del:E.del,hash:E.hash,init:E.init,list:E.list,load:E.load,set:E.set},stylesheet:function(e,t){return d.create("link",{rel:"stylesheet",type:"text/css",href:e,media:t||"print, screen"},s("head")[0])},script:function(e,t,n){return d.create("script",{type:"application/javascript",src:e},t||s("head")[0],n)},stop:x.stop,store:function(e,t){return p.register.call(p,e,t)},tpl:x.tpl,un:function(e,t,n,r){var i=typeof n!="undefined",u,a,f,l;u=i?e:this,a=i?t:e,f=i?n:t,l=i?r:n;if(typeof u=="undefined"||u===s)u=o;return w.remove.call(w,u,a,f,l)},update:d.update,version:"2.8.0",walk:x.walk}}(),typeof o.bootstrap=="function"&&o.bootstrap();switch(!0){case typeof exports!="undefined":module.exports={$:s,abaaso:o};break;case typeof define=="function":define(function(){return o});break;default:e.abaaso=o}})(this)